Index: trunk/doc/Makefile
===================================================================
--- trunk/doc/Makefile	(revision 234)
+++ 	(revision )
@@ -1,35 +1,0 @@
-# $Id$
-
-BUILD_FILES=$(BUILD_DOC)/man/man1/reglookup.1.gz\
-	$(BUILD_DOC)/man/man1/reglookup-timeline.1.gz\
-	$(BUILD_DOC)/man/man1/reglookup-recover.1.gz
-
-default: $(BUILD_FILES)
-
-$(BUILD_DOC)/man/man1:
-	mkdir -p $(BUILD_DOC)/man/man1
-
-$(BUILD_DOC)/man/man1/reglookup.1.gz: man/man1/reglookup.1.gz $(BUILD_DOC)/man/man1
-	cp man/man1/reglookup.1.gz $@
-
-$(BUILD_DOC)/man/man1/reglookup-timeline.1.gz: man/man1/reglookup-timeline.1.gz $(BUILD_DOC)/man/man1
-	cp man/man1/reglookup-timeline.1.gz $@
-
-$(BUILD_DOC)/man/man1/reglookup-recover.1.gz: man/man1/reglookup-recover.1.gz $(BUILD_DOC)/man/man1
-	cp man/man1/reglookup-recover.1.gz $@
-
-install:
-	cp -r $(BUILD_DOC)/* $(DOC_PREFIX)
-	ln -sf $(DOC_PREFIX)/man/man1/*  $(MAN_PREFIX)/man1
-
-
-#XXX: Used during release only
-release:
-	#XXX: The sed filter is a temporary hack to work around a bug in docbook2x-man
-	#     See: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=516165
-	docbook2x-man --to-stdout reglookup.1.docbook | sed 's/.SH DESCRIPTION/\n.SH DESCRIPTION/' > man/man1/reglookup.1
-	docbook2x-man --to-stdout reglookup-timeline.1.docbook | sed 's/.SH DESCRIPTION/\n.SH DESCRIPTION/' > man/man1/reglookup-timeline.1
-	docbook2x-man --to-stdout reglookup-recover.1.docbook | sed 's/.SH DESCRIPTION/\n.SH DESCRIPTION/' > man/man1/reglookup-recover.1
-	cd man/man1 && gzip -9 -f reglookup.1
-	cd man/man1 && gzip -9 -f reglookup-timeline.1
-	cd man/man1 && gzip -9 -f reglookup-recover.1
Index: trunk/doc/mingw-build.txt
===================================================================
--- trunk/doc/mingw-build.txt	(revision 234)
+++ 	(revision )
@@ -1,80 +1,0 @@
-Cross-compiling RegLookup to Windows with MinGW
-===============================================
-
-MinGW can be used to compile Windows binaries from UNIX environments.
-The following instructions outline the steps required to build
-reglookup.exe and reglookup-recover.exe.  This process is experimental
-and Windows binaries have not been well tested.  You have been warned.
-
-Prerequisites
--------------
-
-- Before you start, ensure you have MinGW installed.  Under Debian,
-  install the `mingw32' package.
-
-- Download pre-compiled libiconv packages from here:
-   http://gnuwin32.sourceforge.net/packages/libiconv.htm
-
-  You will need to download the "Binaries" and "Developer files"
-  packages, whose files are named libiconv-VERSION-bin.zip and
-  libiconv-VERSION-lib.zip respectively.
-
-- Unpack both zip files into a designated top-level directory.
-  Suggested commands:
-  $ mkdir /usr/local/src/libiconv-VERSION-bin /usr/local/src/libiconv-VERSION-lib
-  $ cd /usr/local/src/libiconv-VERSION-bin
-  $ unzip .../path/to/libiconv-VERSION-bin.zip
-  $ cd /usr/local/src/libiconv-VERSION-lib
-  $ unzip .../path/to/libiconv-VERSION-lib.zip
-  
-
-Building
---------
-
-Review the top level RegLookup Makefile to ensure the settings match
-your environment.  Find the conditional block which looks like:
-
-################################################################################
-# MinGW cross-compiling build settings
-ifdef BUILD_MINGW
-
-## These may need to be changed
-CC=i586-mingw32msvc-cc
-LIBICONV_PATH=/usr/local/src/libiconv-1.9.2-1-lib
-
-## These probably do not need to be changed
-BIN_EXT=.exe
-INC:=$(INC) -I$(LIBICONV_PATH)/include
-EXTRA_OBJ=$(LIBICONV_PATH)/lib/libiconv.dll.a
-
-endif
-################################################################################
-
-
-If either the CC or LIBICONV_PATH settings are incorrect for your
-system, either update the Makefile, or override these options at build
-time when you run make.  For instance, the above settings in the
-Makefile are correct, you can execute the build by running:
-
-$ make BUILD_MINGW=1
-
-Alternatively, you may override the variables above with:
-
-$ make BUILD_MINGW=1 CC=my-mingw-binary LIBICONV_PATH=.../path/to/libiconv-VERSION-lib
-
-Once the build is complete, you'll find the .exe files under the
-build/bin directory.
-
-
-Installation
-------------
-Naturally, there is no install Makefile target for the MinGW build
-process, since we aren't installing on the local system.  To install
-these binaries on a Windows machine, simply copy over the reglookup.exe
-and reglookup-recover.exe files from the build/bin directory to the
-desired host.  In addition, you will need to install the libiconv2.dll
-file on that host (either in the same directory as the reglookup
-executables, or somewhere in the DLL search path).  This file is
-available in the libiconv-VERSION-bin.zip file you downloaded earlier,
-under the `bin' subdirectory.
-
Index: trunk/src/Makefile
===================================================================
--- trunk/src/Makefile	(revision 234)
+++ 	(revision )
@@ -1,28 +1,0 @@
-# $Id$
-
-################################################################################
-
-REGLOOKUP=$(BUILD_BIN)/reglookup$(BIN_EXT)
-REGLOOKUP_RECOVER=$(BUILD_BIN)/reglookup-recover$(BIN_EXT)
-OBJ=$(wildcard ../lib/*.o)
-FILES=$(REGLOOKUP) $(REGLOOKUP_RECOVER)
-
-all: $(FILES)
-
-$(REGLOOKUP): reglookup.o $(OBJ)
-	$(CC) $(CFLAGS) $(OPTS) $(LIB) -o $@ reglookup.o $(OBJ) $(EXTRA_OBJ)
-
-$(REGLOOKUP_RECOVER): reglookup-recover.o $(OBJ)
-	$(CC) $(CFLAGS) $(OPTS) $(LIB) -o $@ reglookup-recover.o $(OBJ) $(EXTRA_OBJ)
-
-reglookup.o: reglookup.c
-	$(CC) $(CFLAGS) $(OPTS) $(INC) -c -o $@ reglookup.c
-
-reglookup-recover.o: reglookup-recover.c
-	$(CC) $(CFLAGS) $(OPTS) $(INC) -c -o $@ reglookup-recover.c
-
-install:
-	install -m 0755 $(FILES) $(BIN_PREFIX)
-
-clean:
-	rm -f *.o